<?php

namespace Drupal\monarch_block_build_control;

use Drupal\block\BlockViewBuilder as BlockViewBuilderBase;

/**
 * Provides a Block view builder.
 */
class BlockViewBuilder extends BlockViewBuilderBase {

  /**
   * {@inheritdoc}
   */
  public function viewMultiple(array $entities = [], $view_mode = 'full', $langcode = NULL) {
    $build = parent::viewMultiple($entities, $view_mode, $langcode);

    foreach ($entities as $entity) {
      $entity_id = $entity->id();

      if (($build[$entity_id]['#lazy_builder'] ?? NULL) && $entity->getThirdPartySetting('monarch_block_build_control', 'prevent_lazy_build')) {
        unset($build[$entity_id]['#lazy_builder']);
        $build[$entity_id] += static::buildPreRenderableBlock($entity, $this->moduleHandler());
      }
    }

    return $build;
  }

};
